﻿//Future releases will allow adding of addional morphs, and saving settings... still gotta figua those out.

using UnityEngine;
using UnityEngine.UI;
using SimpleJSON;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using MVR.FileManagementSecure;
using System.Runtime;
using Battlehub.RTSaveLoad;
using System.Reflection.Emit;
using Leap.Unity;
using System.IO;
using System.Reflection;
using System.Security.Policy;

namespace AWWalker
{
    public class GenitalMultiPass : MVRScript
    {

        protected string gmpversion = "11.0.0";
        protected int GMP_VERSION = 11;
        protected string isDev = "Release";
        protected string _saveExt = "json";

        private const string _gmpSavePath = "Saves\\PluginData\\AWWMultiPass";
        private const string _gmpLoadPath = "Saves\\PluginData";

        //STATICS
        protected Color cClear = Color.clear;
        protected Color cBlue = Color.blue;
        protected Color cWhite = Color.white;
        protected Color cRed = Color.red;
        protected Color cCyan = Color.cyan;
        protected Color cBlack = Color.black;
        protected Color cGray = Color.gray;
        protected Color cGreen = Color.green;



        private static FreeControllerV3 chest;
        private static FreeControllerV3 lKnee;
        private static FreeControllerV3 rKnee;
        //FROM TEMPLATE 



        protected JSONStorableString jstring;
        protected UIDynamicButton dbutton;
        protected UIDynamicSlider dslider;
        protected UIDynamicTextField dtext;
        protected UIDynamicTextField tfRemapVal;
        protected JSONStorableString xFactorstring;

        protected JSONStorableFloat xFactor;
        private bool rightSide = false;
        private bool leftSide = true;


        private DAZMorph HoodModMorph;
        protected JSONStorableFloat HoodModMorphChangeMin;
        protected JSONStorableFloat HoodModMorphChangeMax;

        private DAZMorph labiaMajoraMorph;
        protected JSONStorableFloat labiaMajoraMorphChangeMin;
        protected JSONStorableFloat labiaMajoraMorphChangeMax;

        private DAZMorph LabMajRMidMorph;
        protected JSONStorableFloat LabMajRMidMorphChangeMin;
        protected JSONStorableFloat LabMajRMidMorphChangeMax;

        private DAZMorph LabMajLUpMorph;
        protected JSONStorableFloat LabMajLUpMorphChangeMin;
        protected JSONStorableFloat LabMajLUpMorphChangeMax;

        private DAZMorph LabMajLMidMorph;
        protected JSONStorableFloat LabMajLMidMorphChangeMin;
        protected JSONStorableFloat LabMajLMidMorphChangeMax;

        private DAZMorph LabMajLLowMorph;
        protected JSONStorableFloat LabMajLLowMorphChangeMin;
        protected JSONStorableFloat LabMajLLowMorphChangeMax;

        private DAZMorph LabMinRMidMorph;
        protected JSONStorableFloat LabMinRMidMorphChangeMin;
        protected JSONStorableFloat LabMinRMidMorphChangeMax;

        private DAZMorph LabMinRUpMorph;
        protected JSONStorableFloat LabMinRUpMorphChangeMin;
        protected JSONStorableFloat LabMinRUpMorphChangeMax;

        private DAZMorph LabMinLLowMorph;
        protected JSONStorableFloat LabMinLLowMorphChangeMin;
        protected JSONStorableFloat LabMinLLowMorphChangeMax;

        private DAZMorph LabMinLUpMorph;
        protected JSONStorableFloat LabMinLUpMorphChangeMin;
        protected JSONStorableFloat LabMinLUpMorphChangeMax;

        private DAZMorph LabMajRLowMorph;
        protected JSONStorableFloat LabMajRLowMorphChangeMin;
        protected JSONStorableFloat LabMajRLowMorphChangeMax;

        private DAZMorph LabMinRLowMorph;
        protected JSONStorableFloat LabMinRLowMorphChangeMin;
        protected JSONStorableFloat LabMinRLowMorphChangeMax;

        private DAZMorph LabMajRUpMorph;
        protected JSONStorableFloat LabMajRUpMorphChangeMin;
        protected JSONStorableFloat LabMajRUpMorphChangeMax;

        private DAZMorph LabMinLMidMorph;
        protected JSONStorableFloat LabMinLMidMorphChangeMin;
        protected JSONStorableFloat LabMinLMidMorphChangeMax;

        private DAZMorph labiaMinoraMorph;
        protected JSONStorableFloat labiaMinoraMorphChangeMin;
        protected JSONStorableFloat labiaMinoraMorphChangeMax;


        private DAZMorph AWW_Majora_LeftUpperTopMorph;
        protected JSONStorableFloat AWW_Majora_LeftUpperTopMorphChangeMin;
        protected JSONStorableFloat AWW_Majora_LeftUpperTopMorphChangeMax;

        private DAZMorph AWW_Majora_RightUpperTopMorph;
        protected JSONStorableFloat AWW_Majora_RightUpperTopMorphChangeMin;
        protected JSONStorableFloat AWW_Majora_RightUpperTopMorphChangeMax;

        private DAZMorph AWW_VagInternal_Size2;
        protected JSONStorableFloat AWW_VagInternal_Size2ChangeMin;
        protected JSONStorableFloat AWW_VagInternal_Size2ChangeMax;

        private DAZMorph AWW_Clitoris_Front_Back;
        protected JSONStorableFloat AWW_Clitoris_Front_BackMin;
        protected JSONStorableFloat AWW_Clitoris_Front_BackMax;

        private DAZMorph AWW_Clitoris_HoodBack;
        protected JSONStorableFloat AWW_Clitoris_HoodBackMax;

        private DAZMorph AWW_Clitoris_Size;
        protected JSONStorableFloat AWW_Clitoris_SizeMax;

        private DAZMorph AWW_Clitoris_HoodSize;
        protected JSONStorableFloat AWW_Clitoris_HoodSizeMax;


        protected JSONStorableFloat OverallIntensity;


        

        public override void Init()
        {
            try
            {

                if (containingAtom.type != "Person")
                {
                    SuperController.LogError($"Plugin for use with 'Person' atom, not '{containingAtom.type}'");
                    return;
                }
                pluginLabelJSON.val = "Multi Pass - AWWalker version:" + gmpversion;
                JSONStorable js = containingAtom.GetStorableByID("geometry");

                if (js != null)
                {
                    DAZCharacterSelector dcs = js as DAZCharacterSelector;
                    GenerateDAZMorphsControlUI morphUI = dcs.morphsControlUI;
                    if (morphUI != null)
                    {
                        //
                        AWW_VagInternal_Size2 = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/AWW_VagInternal_Size2.vmi");
                        if (AWW_VagInternal_Size2 == null)
                        {
                            SuperController.LogError("Couldn't find morph 'AWW_VagInternal_Size2'");
                            AWW_VagInternal_Size2 = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            
                        }

                        AWW_Clitoris_Size = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/AWW_Clitoris_Size.vmi");
                        if (AWW_Clitoris_Size == null)
                        {
                            SuperController.LogError("Couldn't find morph ' AWW_Clitoris_Size'");
                            AWW_Clitoris_Size = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                        }
                        AWW_Clitoris_HoodSize = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/AWW_Clitoris_HoodSize.vmi");
                        if (AWW_Clitoris_HoodSize == null)
                        {
                            SuperController.LogError("Couldn't find morph ' AWW_Clitoris_HoodSize'");
                            AWW_Clitoris_HoodSize = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                        }

                        AWW_Clitoris_HoodBack = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/AWW_Clitoris_HoodBack.vmi");
                        if (AWW_Clitoris_HoodBack == null)
                        {
                            SuperController.LogError("Couldn't find morph ' AWW_Clitoris_HoodBack'");
                            AWW_Clitoris_HoodBack = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                        }
                        AWW_Clitoris_Front_Back = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/AWW_Clitoris_Front_Back.vmi");
                        if (AWW_Clitoris_Front_Back == null)
                        {
                            SuperController.LogError("Couldn't find morph ' AWW_Clitoris_Front_Back'");
                            AWW_Clitoris_Front_Back = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                        }

                        AWW_Majora_LeftUpperTopMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/AWW_Majora_LeftUpperTop.vmi");
                        if (AWW_Majora_LeftUpperTopMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'AWW_Majora_LeftUpperTop'");
                            AWW_Majora_LeftUpperTopMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                        }

                        AWW_Majora_RightUpperTopMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/AWW_Majora_RightUpperTop.vmi");
                        if (AWW_Majora_RightUpperTopMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'AWW_Majora_RightUpperTop'");
                            AWW_Majora_RightUpperTopMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                        }

                        labiaMinoraMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia minora-size.vmi");
                        if (labiaMinoraMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia minora-size'");
                            labiaMinoraMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                        }

                        HoodModMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/HoodMod.vmi");
                        if (HoodModMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'HoodMod'");
                            HoodModMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                        }

                        labiaMajoraMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia majora-relaxation.vmi");
                        if (labiaMajoraMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia majora-relaxation'");
                            labiaMajoraMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                        }

                        LabMajRMidMorph = morphUI.GetMorphByDisplayName("Labia majora-spread-RMid");
                        if (LabMajRMidMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia majora-spread-RMid'");
                            LabMajRMidMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                        }

                        LabMajLUpMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia majora-spread-LUp.vmi");
                        if (LabMajLUpMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia majora-spread-LUp'");
                            LabMajLUpMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                        }

                        LabMajLMidMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia majora-spread-LMid.vmi");
                        if (LabMajLMidMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia majora-spread-LMid'");
                            LabMajLMidMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                        }

                        LabMajLLowMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia majora-spread-LLow.vmi");
                        if (LabMajLLowMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia majora-spread-LLow'");
                            LabMajLLowMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                        }

                        LabMinRMidMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia minora-spread-RMid.vmi");
                        if (LabMinRMidMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia minora-spread-RMid'");
                            LabMinRMidMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                        }
                        //(* needsStore fix*)
                        LabMinRUpMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia minora-spread-RUp.vmi");
                        if (LabMinRUpMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia minora-spread-RUp'");
                            LabMinRUpMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend"); 
                        }

                        LabMinLLowMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia minora-spread-LLow.vmi");
                        if (LabMinLLowMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia minora-spread-LLow'");
                            LabMinLLowMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                        }

                        LabMinLUpMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia minora-spread-LUp.vmi");
                        if (LabMinLUpMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia minora-spread-LUp'");
                            LabMinLUpMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                        }

                        LabMajRLowMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia majora-spread-RLow.vmi");
                        if (LabMajRLowMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia majora-spread-RLow'");
                            LabMajRLowMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                        }

                        LabMinRLowMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia minora-spread-RLow.vmi");
                        if (LabMinRLowMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia minora-spread-RLow'");
                            LabMinRLowMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                        }

                        LabMajRUpMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia majora-spread-RUp.vmi");
                        if (LabMajRUpMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia majora-spread-RUp'");
                            LabMajRUpMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");


                        }

                        LabMinLMidMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia minora-spread-LMid.vmi");
                        if (LabMinLMidMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia minora-spread-LMid'");
                            LabMinLMidMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                        }

                    }
                }
                chest = containingAtom.GetStorableByID("chestControl") as FreeControllerV3;
                lKnee = containingAtom.GetStorableByID("lKneeControl") as FreeControllerV3;
                rKnee = containingAtom.GetStorableByID("rKneeControl") as FreeControllerV3;

                OverallIntensity = new JSONStorableFloat("Intensity", 1f, 0f, 2f, false, true);
                OverallIntensity.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(OverallIntensity);
                AWW_Clitoris_HoodSizeMax = new JSONStorableFloat("AWW Hood Size", 0f, -1f, 1f, false, true);
                AWW_Clitoris_HoodSizeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(AWW_Clitoris_HoodSizeMax);

                AWW_Clitoris_SizeMax = new JSONStorableFloat("AWW Clitoris Size", 0f, -1f, 1f, false, true);
                AWW_Clitoris_SizeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(AWW_Clitoris_SizeMax);

                AWW_Clitoris_HoodBackMax = new JSONStorableFloat("Hood Back/Forward", 0f, -1f, 1f, false, true);
                AWW_Clitoris_HoodBackMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(AWW_Clitoris_HoodBackMax);

                AWW_Clitoris_Front_BackMax = new JSONStorableFloat("AWW Clitoris Front_Back", 0f, lmin => AWW_Clitoris_Front_BackMax.SetVal(Mathf.Max(AWW_Clitoris_Front_BackMax.val, lmin)), 0f, 1f, false, true);
                AWW_Clitoris_Front_BackMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(AWW_Clitoris_Front_BackMax);

                AWW_VagInternal_Size2ChangeMin = new JSONStorableFloat("AWW_VagInternal_Size Min", 0f, lmin => AWW_VagInternal_Size2ChangeMax.SetVal(Mathf.Max(AWW_VagInternal_Size2ChangeMax.val, lmin)), 0f, 1f, false, true);
                AWW_VagInternal_Size2ChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(AWW_VagInternal_Size2ChangeMin);

                AWW_VagInternal_Size2ChangeMax = new JSONStorableFloat("AWW_VagInternal_Size Max", 1f, lmax => AWW_VagInternal_Size2ChangeMin.SetVal(Mathf.Min(AWW_VagInternal_Size2ChangeMin.val, lmax)), 0f, 1f, false, true);
                AWW_VagInternal_Size2ChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(AWW_VagInternal_Size2ChangeMax);

                HoodModMorphChangeMin = new JSONStorableFloat("Labia HoodMod Min", 0.0f, lmin => HoodModMorphChangeMax.SetVal(Mathf.Max(HoodModMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                HoodModMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(HoodModMorphChangeMin);

                HoodModMorphChangeMax = new JSONStorableFloat("Labia HoodMod Max", 0.87f, lmax => HoodModMorphChangeMin.SetVal(Mathf.Min(HoodModMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                HoodModMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(HoodModMorphChangeMax);

                labiaMajoraMorphChangeMin = new JSONStorableFloat("Labia Majora Morph Min", -1.21f, lmin => labiaMajoraMorphChangeMax.SetVal(Mathf.Max(labiaMajoraMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                labiaMajoraMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(labiaMajoraMorphChangeMin);

                labiaMajoraMorphChangeMax = new JSONStorableFloat("Labia Majora Morph Max", 2f, lmax => labiaMajoraMorphChangeMin.SetVal(Mathf.Min(labiaMajoraMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                labiaMajoraMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(labiaMajoraMorphChangeMax);

                AWW_Majora_LeftUpperTopMorphChangeMin = new JSONStorableFloat("Left Top Morph Min", -0.4f, lmin => AWW_Majora_LeftUpperTopMorphChangeMax.SetVal(Mathf.Max(AWW_Majora_LeftUpperTopMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                AWW_Majora_LeftUpperTopMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(AWW_Majora_LeftUpperTopMorphChangeMin);

                AWW_Majora_LeftUpperTopMorphChangeMax = new JSONStorableFloat("Left Top Morph Max", 0.9f, lmax => AWW_Majora_LeftUpperTopMorphChangeMin.SetVal(Mathf.Min(AWW_Majora_LeftUpperTopMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                AWW_Majora_LeftUpperTopMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(AWW_Majora_LeftUpperTopMorphChangeMax);

                AWW_Majora_RightUpperTopMorphChangeMin = new JSONStorableFloat("Right Top Morph Min", -0.4f, lmin => AWW_Majora_RightUpperTopMorphChangeMax.SetVal(Mathf.Max(AWW_Majora_RightUpperTopMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                AWW_Majora_RightUpperTopMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(AWW_Majora_RightUpperTopMorphChangeMin);

                AWW_Majora_RightUpperTopMorphChangeMax = new JSONStorableFloat("Right Top Morph Max", 0.9f, lmax => AWW_Majora_RightUpperTopMorphChangeMin.SetVal(Mathf.Min(AWW_Majora_RightUpperTopMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                AWW_Majora_RightUpperTopMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(AWW_Majora_RightUpperTopMorphChangeMax);

                LabMajLUpMorphChangeMin = new JSONStorableFloat("Labia LabMajLUp Min", -0.45f, lmin => LabMajLUpMorphChangeMax.SetVal(Mathf.Max(LabMajLUpMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMajLUpMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajLUpMorphChangeMin);

                LabMajLUpMorphChangeMax = new JSONStorableFloat("Labia LabMajLUp Max", 0.35f, lmax => LabMajLUpMorphChangeMin.SetVal(Mathf.Min(LabMajLUpMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMajLUpMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajLUpMorphChangeMax);

                LabMajRUpMorphChangeMin = new JSONStorableFloat("Labia LabMajRUp Min", -0.45f, lmin => LabMajRUpMorphChangeMax.SetVal(Mathf.Max(LabMajRUpMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMajRUpMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajRUpMorphChangeMin);

                LabMajRUpMorphChangeMax = new JSONStorableFloat("Labia LabMajRUp Max", 0.35f, lmax => LabMajRUpMorphChangeMin.SetVal(Mathf.Min(LabMajRUpMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMajRUpMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajRUpMorphChangeMax);

                LabMajLMidMorphChangeMin = new JSONStorableFloat("Labia LabMajLMid Min", 0.25f, lmin => LabMajLMidMorphChangeMax.SetVal(Mathf.Max(LabMajLMidMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMajLMidMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajLMidMorphChangeMin);

                LabMajLMidMorphChangeMax = new JSONStorableFloat("Labia LabMajLMid Max", 0.4f, lmax => LabMajLMidMorphChangeMin.SetVal(Mathf.Min(LabMajLMidMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMajLMidMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajLMidMorphChangeMax);

                LabMajRMidMorphChangeMin = new JSONStorableFloat("Labia LabMajRMid Min", 0.25f, lmin => LabMajRMidMorphChangeMax.SetVal(Mathf.Max(LabMajRMidMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMajRMidMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajRMidMorphChangeMin);

                LabMajRMidMorphChangeMax = new JSONStorableFloat("Labia LabMajRMid Max", 0.4f, lmax => LabMajRMidMorphChangeMin.SetVal(Mathf.Min(LabMajRMidMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMajRMidMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajRMidMorphChangeMax);

                LabMajLLowMorphChangeMin = new JSONStorableFloat("Labia LabMajLLow Min", 0.25f, lmin => LabMajLLowMorphChangeMax.SetVal(Mathf.Max(LabMajLLowMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMajLLowMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajLLowMorphChangeMin);

                LabMajLLowMorphChangeMax = new JSONStorableFloat("Labia LabMajLLow Max", 0.65f, lmax => LabMajLLowMorphChangeMin.SetVal(Mathf.Min(LabMajLLowMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMajLLowMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajLLowMorphChangeMax);

                LabMajRLowMorphChangeMin = new JSONStorableFloat("Labia LabMajRLow Min", 0.25f, lmin => LabMajRLowMorphChangeMax.SetVal(Mathf.Max(LabMajRLowMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMajRLowMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajRLowMorphChangeMin);

                LabMajRLowMorphChangeMax = new JSONStorableFloat("Labia LabMajRLow Max", 0.65f, lmax => LabMajRLowMorphChangeMin.SetVal(Mathf.Min(LabMajRLowMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMajRLowMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajRLowMorphChangeMax);

                //Minora 

                labiaMinoraMorphChangeMin = new JSONStorableFloat("Labia Minora Morph Min", -0.7f, lmin => labiaMinoraMorphChangeMax.SetVal(Mathf.Max(labiaMinoraMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                labiaMinoraMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(labiaMinoraMorphChangeMin);

                labiaMinoraMorphChangeMax = new JSONStorableFloat("Labia Minora Morph Max", 1f, lmax => labiaMinoraMorphChangeMin.SetVal(Mathf.Min(labiaMinoraMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                labiaMinoraMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(labiaMinoraMorphChangeMax);

                LabMinLUpMorphChangeMin = new JSONStorableFloat("Labia LabMinLUp Min", -0.25f, lmin => LabMinLUpMorphChangeMax.SetVal(Mathf.Max(LabMinLUpMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMinLUpMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinLUpMorphChangeMin);

                LabMinLUpMorphChangeMax = new JSONStorableFloat("Labia LabMinLUp Max", 0.8f, lmax => LabMinLUpMorphChangeMin.SetVal(Mathf.Min(LabMinLUpMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMinLUpMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinLUpMorphChangeMax);


                LabMinRUpMorphChangeMin = new JSONStorableFloat("Labia LabMinRUp Min", -0.25f, lmin => LabMinRUpMorphChangeMax.SetVal(Mathf.Max(LabMinRUpMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMinRUpMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinRUpMorphChangeMin);

                LabMinRUpMorphChangeMax = new JSONStorableFloat("Labia LabMinRUp Max", 0.8f, lmax => LabMinRUpMorphChangeMin.SetVal(Mathf.Min(LabMinRUpMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMinRUpMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinRUpMorphChangeMax);

                LabMinLMidMorphChangeMin = new JSONStorableFloat("Labia LabMinLMid Min", -0.1f, lmin => LabMinLMidMorphChangeMax.SetVal(Mathf.Max(LabMinLMidMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMinLMidMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinLMidMorphChangeMin);

                LabMinLMidMorphChangeMax = new JSONStorableFloat("Labia LabMinLMid Max", 0.50f, lmax => LabMinLMidMorphChangeMin.SetVal(Mathf.Min(LabMinLMidMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMinLMidMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinLMidMorphChangeMax);

                LabMinRMidMorphChangeMin = new JSONStorableFloat("Labia LabMinRMid Min", -0.1f, lmin => LabMinRMidMorphChangeMax.SetVal(Mathf.Max(LabMinRMidMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMinRMidMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinRMidMorphChangeMin);

                LabMinRMidMorphChangeMax = new JSONStorableFloat("Labia LabMinRMid Max", 0.50f, lmax => LabMinRMidMorphChangeMin.SetVal(Mathf.Min(LabMinRMidMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMinRMidMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinRMidMorphChangeMax);


                LabMinLLowMorphChangeMin = new JSONStorableFloat("Labia LabMinLLow Min", 0f, lmin => LabMinLLowMorphChangeMax.SetVal(Mathf.Max(LabMinLLowMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMinLLowMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinLLowMorphChangeMin);

                LabMinRLowMorphChangeMax = new JSONStorableFloat("Labia LabMinRLow Max", 0.75f, lmax => LabMinRLowMorphChangeMin.SetVal(Mathf.Min(LabMinRLowMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMinRLowMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinRLowMorphChangeMax);

                LabMinRLowMorphChangeMin = new JSONStorableFloat("Labia LabMinRLow Min", 0f, lmin => LabMinRLowMorphChangeMax.SetVal(Mathf.Max(LabMinRLowMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMinRLowMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinRLowMorphChangeMin);

                LabMinLLowMorphChangeMax = new JSONStorableFloat("Labia LabMinLLow Max", 0.75f, lmax => LabMinLLowMorphChangeMin.SetVal(Mathf.Min(LabMinLLowMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMinLLowMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinLLowMorphChangeMax);



                //Create UI

        

                string txtTitle = "AWWalker's Genital Multi-Pass\nKudos to: VeeRifter & MacGruber \nVersion: " + gmpversion + " " + isDev;
                

                JSONStorableString strTitle = new JSONStorableString("Title", txtTitle);
                UIDynamicTextField textfieldtitl = CreateTextField(strTitle, rightSide);



                var savePresetUI = CreateButton("Save Preset",true);
                savePresetUI.button.onClick.AddListener(() =>
                {
                    FileManagerSecure.CreateDirectory(_gmpSavePath);
                    var fileBrowserUI = SuperController.singleton.fileBrowserUI;

                    fileBrowserUI.SetTitle("Save colliders preset");
                    fileBrowserUI.fileFormat = "json";
                    fileBrowserUI.showFiles = true;
                    fileBrowserUI.fileRemovePrefix = null;
                    fileBrowserUI.hideExtension = false;
                    fileBrowserUI.keepOpen = false;
                    fileBrowserUI.fileFormat = _saveExt;
                    fileBrowserUI.defaultPath = _gmpSavePath;
                    fileBrowserUI.showDirs = true;
                    fileBrowserUI.SetTextEntry(true);
                    fileBrowserUI.Show(saveUI);
                    fileBrowserUI.fileEntryField.text = (int)(DateTime.UtcNow - new DateTime(1970, 1, 1)).TotalSeconds + "." + _saveExt;
                    fileBrowserUI.ActivateFileNameField();
                });

                var loadPresetUI = CreateButton("Load Preset", true);
                loadPresetUI.button.onClick.AddListener(() =>
                {
                    FileManagerSecure.CreateDirectory(_gmpLoadPath);
                    var shortcuts = FileManagerSecure.GetShortCutsForDirectory(_gmpLoadPath);
                    SuperController.singleton.GetMediaPathDialog(gacLoadSettings, _saveExt, _gmpLoadPath, false, true, false, null, false, shortcuts);
                });


                textfieldtitl.height = 150;
                textfieldtitl.textColor = UnityEngine.Color.blue;
                textfieldtitl.backgroundColor = cClear;
                //textfielddesc.backgroundImage 
                UIDynamicButton btnDefaults = CreateButton("Load Defaults", true);
                btnDefaults.button.onClick.AddListener(RestoreAllFromDefaults);
                btnDefaults.buttonText.fontSize = 28;

                createLeftSPACER(50);
                createRightSPACER(155);

                createSLIDER(OverallIntensity, Color.black, false);
                
                createTitle("Static Morphs", cBlue);


                UIDynamicSlider sldClitHoodBack = CreateSlider(AWW_Clitoris_HoodBackMax, false);
                UIDynamicSlider sldClitHoodFB = CreateSlider(AWW_Clitoris_Front_BackMax, true);
                UIDynamicSlider sldClitSize = CreateSlider(AWW_Clitoris_SizeMax, true);
                UIDynamicSlider sldClitHoodSize = CreateSlider(AWW_Clitoris_HoodSizeMax, false);

                createTitle("Centered Morphs",cBlue);

                createSLIDER(HoodModMorphChangeMin, cBlue, false);
                createSLIDER(HoodModMorphChangeMax, cBlue,   true);
                
                createSLIDER(AWW_VagInternal_Size2ChangeMin, cBlue,   false);
                createSLIDER(AWW_VagInternal_Size2ChangeMax, cBlue,   true);


                // Majora

                //title
                createTitle("Labia Majora", cBlack);

                createSLIDER(labiaMajoraMorphChangeMin, cBlue,   false);
                createSLIDER(labiaMajoraMorphChangeMax, cBlue,   true);

                createSLIDER(AWW_Majora_RightUpperTopMorphChangeMin, cBlue,   false);
                createSLIDER(AWW_Majora_RightUpperTopMorphChangeMax, cBlue,   true);

                createSLIDER(AWW_Majora_LeftUpperTopMorphChangeMin, cBlue,   false);
                createSLIDER(AWW_Majora_LeftUpperTopMorphChangeMax, cBlue,   true);

                createSLIDER(LabMajRUpMorphChangeMin, cBlue,   false);
                createSLIDER(LabMajRUpMorphChangeMax, cBlue,  true);

                createSLIDER(LabMajLUpMorphChangeMin, cBlue,   false);
                createSLIDER(LabMajLUpMorphChangeMax, cBlue,   true);

                createSLIDER(LabMajRMidMorphChangeMin, cBlue,   false);
                createSLIDER(LabMajRMidMorphChangeMax, cBlue,   true);

                createSLIDER(LabMajLMidMorphChangeMin, cBlue,   false);
                createSLIDER(LabMajLMidMorphChangeMax, cBlue,   true);

                createSLIDER(LabMajRLowMorphChangeMin, cBlue,   false);
                createSLIDER(LabMajRLowMorphChangeMax, cBlue,   true);

                createSLIDER(LabMajLLowMorphChangeMin, cBlue,   false);
                createSLIDER(LabMajLLowMorphChangeMax, cBlue,   true);


                // Minora
                createTitle("Labia Minora", cBlack);
                createSLIDER(labiaMinoraMorphChangeMin, cBlue, false);
                createSLIDER(labiaMinoraMorphChangeMax, cBlue, true);

                createSLIDER(LabMinRUpMorphChangeMin, cBlue,   false);
                createSLIDER(LabMinRUpMorphChangeMax, cBlue,   true);

                createSLIDER(LabMinLUpMorphChangeMin, cBlue,   false);
                createSLIDER(LabMinLUpMorphChangeMax, cBlue,   true);

                createSLIDER(LabMinRMidMorphChangeMin, cBlue,   false);
                createSLIDER(LabMinRMidMorphChangeMax, cBlue,   true);

                createSLIDER(LabMinLMidMorphChangeMin, cBlue,   false);
                createSLIDER(LabMinLMidMorphChangeMax, cBlue,   true);

                createSLIDER(LabMinRLowMorphChangeMin, cBlue,   false);
                createSLIDER(LabMinRLowMorphChangeMax, cBlue,   true);

                createSLIDER(LabMinLLowMorphChangeMin, cBlue,   false);
                createSLIDER(LabMinLLowMorphChangeMax, cBlue,   true);

                createSLIDER(AWW_Clitoris_Front_BackMax, cBlue,   true);


                JSONStorableFloat v = new JSONStorableFloat("v", 3f,0f,5f);
                v.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(v);


            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        public static string GetPluginPath(MVRScript self)
        {
            string id = self.name.Substring(0, self.name.IndexOf('_'));
            string filename = self.manager.GetJSON()["plugins"][id].Value;
            return filename.Substring(0, filename.LastIndexOfAny(new char[] { '/', '\\' }));
        }

        private void gacSaveSettings()
        {
            SuperController.LogMessage(allParams.Count.ToString());
            SuperController.LogMessage(allParams.ToArrayString());
            JSONStorable.copyStore1.SaveToFile("poop.json");
            //copyStore1.SaveToFile("Custom/Scripts/AWWalker/AWWMultiPass/Prefs/test.gmp");
            //saveUI("Custom/Scripts/AWWalker/AWWMultiPass/Prefs/");



        }



        private void saveUI(string path)
        {

            
            SuperController.singleton.fileBrowserUI.fileFormat = null;
            if (string.IsNullOrEmpty(path)) return;
            if (!path.ToLower().EndsWith($".{_saveExt}")) path += $".{_saveExt}";

            if (!path.ToLower().EndsWith($".{_saveExt}"))
                path += $".{_saveExt}";

            JSONClass jc = new JSONClass();
            JSONClass info = new JSONClass();
            info["Format"] = "AWWalker.MultiPass";
            info["Version"].AsInt = GMP_VERSION;
            string creatorName = UserPreferences.singleton.creatorName;
            if (string.IsNullOrEmpty(creatorName))
                creatorName = "Unknown";
            info["Author"] = creatorName;
            jc["Info"] = info;

            jc["OverallIntensity"].AsFloat = OverallIntensity.val;
            jc["AWW_Clitoris_HoodSizeMax"].AsFloat = AWW_Clitoris_HoodSizeMax.val;
            jc["AWW_Clitoris_SizeMax"].AsFloat = AWW_Clitoris_SizeMax.val;
            jc["AWW_Clitoris_HoodBackMax"].AsFloat = AWW_Clitoris_HoodBackMax.val;
            jc["AWW_Clitoris_Front_BackMax"].AsFloat = AWW_Clitoris_Front_BackMax.val;
            jc["AWW_VagInternal_Size2ChangeMin"].AsFloat = AWW_VagInternal_Size2ChangeMin.val;
            jc["AWW_VagInternal_Size2ChangeMax"].AsFloat = AWW_VagInternal_Size2ChangeMax.val;
            jc["HoodModMorphChangeMin"].AsFloat = HoodModMorphChangeMin.val;
            jc["HoodModMorphChangeMax"].AsFloat = HoodModMorphChangeMax.val;
            jc["labiaMajoraMorphChangeMin"].AsFloat = labiaMajoraMorphChangeMin.val;
            jc["labiaMajoraMorphChangeMax"].AsFloat = labiaMajoraMorphChangeMax.val;
            jc["AWW_Majora_LeftUpperTopMorphChangeMin"].AsFloat = AWW_Majora_LeftUpperTopMorphChangeMin.val;
            jc["AWW_Majora_LeftUpperTopMorphChangeMax"].AsFloat = AWW_Majora_LeftUpperTopMorphChangeMax.val;
            jc["AWW_Majora_RightUpperTopMorphChangeMin"].AsFloat = AWW_Majora_RightUpperTopMorphChangeMin.val;
            jc["AWW_Majora_RightUpperTopMorphChangeMax"].AsFloat = AWW_Majora_RightUpperTopMorphChangeMax.val;
            jc["LabMajLUpMorphChangeMin"].AsFloat = LabMajLUpMorphChangeMin.val;
            jc["LabMajLUpMorphChangeMax"].AsFloat = LabMajLUpMorphChangeMax.val;
            jc["LabMajRUpMorphChangeMin"].AsFloat = LabMajRUpMorphChangeMin.val;
            jc["LabMajRUpMorphChangeMax"].AsFloat = LabMajRUpMorphChangeMax.val;
            jc["LabMajLMidMorphChangeMin"].AsFloat = LabMajLMidMorphChangeMin.val;
            jc["LabMajLMidMorphChangeMax"].AsFloat = LabMajLMidMorphChangeMax.val;
            jc["LabMajRMidMorphChangeMin"].AsFloat = LabMajRMidMorphChangeMin.val;
            jc["LabMajRMidMorphChangeMax"].AsFloat = LabMajRMidMorphChangeMax.val;
            jc["LabMajLLowMorphChangeMin"].AsFloat = LabMajLLowMorphChangeMin.val;
            jc["LabMajLLowMorphChangeMax"].AsFloat = LabMajLLowMorphChangeMax.val;
            jc["LabMajRLowMorphChangeMin"].AsFloat = LabMajRLowMorphChangeMin.val;
            jc["LabMajRLowMorphChangeMax"].AsFloat = LabMajRLowMorphChangeMax.val;
            jc["labiaMinoraMorphChangeMin"].AsFloat = labiaMinoraMorphChangeMin.val;
            jc["labiaMinoraMorphChangeMax"].AsFloat = labiaMinoraMorphChangeMax.val;
            jc["LabMinLUpMorphChangeMin"].AsFloat = LabMinLUpMorphChangeMin.val;
            jc["LabMinLUpMorphChangeMax"].AsFloat = LabMinLUpMorphChangeMax.val;
            jc["LabMinRUpMorphChangeMin"].AsFloat = LabMinRUpMorphChangeMin.val;
            jc["LabMinRUpMorphChangeMax"].AsFloat = LabMinRUpMorphChangeMax.val;
            jc["LabMinLMidMorphChangeMin"].AsFloat = LabMinLMidMorphChangeMin.val;
            jc["LabMinLMidMorphChangeMax"].AsFloat = LabMinLMidMorphChangeMax.val;
            jc["LabMinRMidMorphChangeMin"].AsFloat = LabMinRMidMorphChangeMin.val;
            jc["LabMinRMidMorphChangeMax"].AsFloat = LabMinRMidMorphChangeMax.val;
            jc["LabMinLLowMorphChangeMin"].AsFloat = LabMinLLowMorphChangeMin.val;
            jc["LabMinRLowMorphChangeMax"].AsFloat = LabMinRLowMorphChangeMax.val;
            jc["LabMinRLowMorphChangeMin"].AsFloat = LabMinRLowMorphChangeMin.val;
            jc["LabMinLLowMorphChangeMax"].AsFloat = LabMinLLowMorphChangeMax.val;

            SaveJSON(jc, path);





        }




        private void gacLoadSettings(string path)
        {
            if (string.IsNullOrEmpty(path))
                return;

            JSONClass jc = LoadJSON(path).AsObject;
            
            try { OverallIntensity.val = jc["OverallIntensity"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :OverallIntensity"); }
            try { AWW_Clitoris_HoodSizeMax.val = jc["AWW_Clitoris_HoodSizeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_Clitoris_HoodSizeMax"); }
            try { AWW_Clitoris_SizeMax.val = jc["AWW_Clitoris_SizeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_Clitoris_SizeMax"); }
            try { AWW_Clitoris_HoodBackMax.val = jc["AWW_Clitoris_HoodBackMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_Clitoris_HoodBackMax"); }
            try { AWW_Clitoris_Front_BackMax.val = jc["AWW_Clitoris_Front_BackMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_Clitoris_Front_BackMax"); }
            try { AWW_VagInternal_Size2ChangeMin.val = jc["AWW_VagInternal_Size2ChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_VagInternal_Size2ChangeMin"); }
            try { AWW_VagInternal_Size2ChangeMax.val = jc["AWW_VagInternal_Size2ChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_VagInternal_Size2ChangeMax"); }
            try { HoodModMorphChangeMin.val = jc["HoodModMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :HoodModMorphChangeMin"); }
            try { HoodModMorphChangeMax.val = jc["HoodModMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :HoodModMorphChangeMax"); }
            try { labiaMajoraMorphChangeMin.val = jc["labiaMajoraMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :labiaMajoraMorphChangeMin"); }
            try { labiaMajoraMorphChangeMax.val = jc["labiaMajoraMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :labiaMajoraMorphChangeMax"); }
            try { AWW_Majora_LeftUpperTopMorphChangeMin.val = jc["AWW_Majora_LeftUpperTopMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_Majora_LeftUpperTopMorphChangeMin"); }
            try { AWW_Majora_LeftUpperTopMorphChangeMax.val = jc["AWW_Majora_LeftUpperTopMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_Majora_LeftUpperTopMorphChangeMax"); }
            try { AWW_Majora_RightUpperTopMorphChangeMin.val = jc["AWW_Majora_RightUpperTopMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_Majora_RightUpperTopMorphChangeMin"); }
            try { AWW_Majora_RightUpperTopMorphChangeMax.val = jc["AWW_Majora_RightUpperTopMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_Majora_RightUpperTopMorphChangeMax"); }
            try { LabMajLUpMorphChangeMin.val = jc["LabMajLUpMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajLUpMorphChangeMin"); }
            try { LabMajLUpMorphChangeMax.val = jc["LabMajLUpMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajLUpMorphChangeMax"); }
            try { LabMajRUpMorphChangeMin.val = jc["LabMajRUpMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajRUpMorphChangeMin"); }
            try { LabMajRUpMorphChangeMax.val = jc["LabMajRUpMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajRUpMorphChangeMax"); }
            try { LabMajLMidMorphChangeMin.val = jc["LabMajLMidMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajLMidMorphChangeMin"); }
            try { LabMajLMidMorphChangeMax.val = jc["LabMajLMidMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajLMidMorphChangeMax"); }
            try { LabMajRMidMorphChangeMin.val = jc["LabMajRMidMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajRMidMorphChangeMin"); }
            try { LabMajRMidMorphChangeMax.val = jc["LabMajRMidMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajRMidMorphChangeMax"); }
            try { LabMajLLowMorphChangeMin.val = jc["LabMajLLowMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajLLowMorphChangeMin"); }
            try { LabMajLLowMorphChangeMax.val = jc["LabMajLLowMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajLLowMorphChangeMax"); }
            try { LabMajRLowMorphChangeMin.val = jc["LabMajRLowMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajRLowMorphChangeMin"); }
            try { LabMajRLowMorphChangeMax.val = jc["LabMajRLowMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajRLowMorphChangeMax"); }
            try { labiaMinoraMorphChangeMin.val = jc["labiaMinoraMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :labiaMinoraMorphChangeMin"); }
            try { labiaMinoraMorphChangeMax.val = jc["labiaMinoraMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :labiaMinoraMorphChangeMax"); }
            try { LabMinLUpMorphChangeMin.val = jc["LabMinLUpMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinLUpMorphChangeMin"); }
            try { LabMinLUpMorphChangeMax.val = jc["LabMinLUpMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinLUpMorphChangeMax"); }
            try { LabMinRUpMorphChangeMin.val = jc["LabMinRUpMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinRUpMorphChangeMin"); }
            try { LabMinRUpMorphChangeMax.val = jc["LabMinRUpMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinRUpMorphChangeMax"); }
            try { LabMinLMidMorphChangeMin.val = jc["LabMinLMidMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinLMidMorphChangeMin"); }
            try { LabMinLMidMorphChangeMax.val = jc["LabMinLMidMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinLMidMorphChangeMax"); }
            try { LabMinRMidMorphChangeMin.val = jc["LabMinRMidMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinRMidMorphChangeMin"); }
            try { LabMinRMidMorphChangeMax.val = jc["LabMinRMidMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinRMidMorphChangeMax"); }
            try { LabMinLLowMorphChangeMin.val = jc["LabMinLLowMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinLLowMorphChangeMin"); }
            try { LabMinRLowMorphChangeMax.val = jc["LabMinRLowMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinRLowMorphChangeMax"); }
            try { LabMinRLowMorphChangeMin.val = jc["LabMinRLowMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinRLowMorphChangeMin"); }
            try { LabMinLLowMorphChangeMax.val = jc["LabMinLLowMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinLLowMorphChangeMax"); }

        }

        public void Update()
        {


            Vector3 chestPos = chest.followWhenOff.position;
            Vector3 lKneePos = lKnee.followWhenOff.position;
            Vector3 rKneePos = rKnee.followWhenOff.position;
            Vector3 direction = lKneePos - rKneePos;
            float rKneeTolKnee = direction.magnitude;
            direction = lKneePos - chestPos;
            float lKneeToChest = direction.magnitude;
            direction = rKneePos - chestPos;
            float rKneeToChest = direction.magnitude;
            float spread = rKneeTolKnee - (Mathf.Abs(lKneeToChest - rKneeToChest) * 2);
            
            
            try { HoodModMorph.morphValue = Remap(spread, 0, 1, HoodModMorphChangeMin.val, HoodModMorphChangeMax.val); } catch { }
            try { labiaMajoraMorph.morphValue = Remap(spread, 0, 1, labiaMajoraMorphChangeMin.val, labiaMajoraMorphChangeMax.val); } catch { }
            try { LabMajRMidMorph.morphValue = Remap(spread, 0, 1, LabMajRMidMorphChangeMin.val, LabMajRMidMorphChangeMax.val); } catch { }
            try { LabMajLUpMorph.morphValue = Remap(spread, 0, 1, LabMajLUpMorphChangeMin.val, LabMajLUpMorphChangeMax.val); } catch { }
            try { LabMajLMidMorph.morphValue = Remap(spread, 0, 1, LabMajLMidMorphChangeMin.val, LabMajLMidMorphChangeMax.val); } catch { }
            try { LabMajLLowMorph.morphValue = Remap(spread, 0, 1, LabMajLLowMorphChangeMin.val, LabMajLLowMorphChangeMax.val); } catch { }
            try { LabMajRLowMorph.morphValue = Remap(spread, 0, 1, LabMajRLowMorphChangeMin.val, LabMajRLowMorphChangeMax.val); } catch { }
            try { LabMajRUpMorph.morphValue = Remap(spread, 0, 1, LabMajRUpMorphChangeMin.val, LabMajRUpMorphChangeMax.val); } catch { }
            try { labiaMinoraMorph.morphValue = Remap(spread, 0, 1, labiaMinoraMorphChangeMin.val, labiaMinoraMorphChangeMax.val); } catch { }
            // Negatives below fix the movent direction of the morph
            // Debug line -- SuperController.LogMessage(LabMajLMidMorph.morphValue.ToString());
            try { AWW_Majora_LeftUpperTopMorph.morphValue = Remap(-spread, 0, 1, -AWW_Majora_LeftUpperTopMorphChangeMin.val, AWW_Majora_LeftUpperTopMorphChangeMax.val); } catch { }
            try
            {
                AWW_Majora_RightUpperTopMorph.morphValue = Remap(-spread, 0, 1, -AWW_Majora_RightUpperTopMorphChangeMin.val, AWW_Majora_RightUpperTopMorphChangeMax.val);

                try { LabMinRUpMorph.morphValue = Remap(spread, 0, 1, LabMinRUpMorphChangeMin.val, LabMinRUpMorphChangeMax.val); } catch { }
                try { LabMinLUpMorph.morphValue = Remap(spread, 0, 1, LabMinLUpMorphChangeMin.val, LabMinLUpMorphChangeMax.val); } catch { }
                try { LabMinRMidMorph.morphValue = Remap(spread, 0, 1, LabMinRMidMorphChangeMin.val, LabMinRMidMorphChangeMax.val); } catch { }
                try { LabMinLMidMorph.morphValue = Remap(spread, 0, 1, LabMinLMidMorphChangeMin.val, LabMinLMidMorphChangeMax.val); } catch { }
                try { LabMinRLowMorph.morphValue = Remap(-spread, 0, 1, LabMinRLowMorphChangeMin.val, -LabMinRLowMorphChangeMax.val); } catch { }
                try { LabMinLLowMorph.morphValue = Remap(-spread, 0, 1, LabMinLLowMorphChangeMin.val, -LabMinLLowMorphChangeMax.val); } catch { }


                try { AWW_VagInternal_Size2.morphValue = Remap(spread, 0, 1, AWW_VagInternal_Size2ChangeMin.val, AWW_VagInternal_Size2ChangeMax.val); } catch { }

                try { AWW_Clitoris_Front_Back.morphValue = Remap(1, 0, 1, AWW_Clitoris_Front_BackMax.val, AWW_Clitoris_Front_BackMax.val); }
                catch { }

                try { AWW_Clitoris_HoodBack.morphValue = Remap(1, 0, 1, AWW_Clitoris_HoodBackMax.val, AWW_Clitoris_HoodBackMax.val); }
                catch { }

                try { AWW_Clitoris_Size.morphValue = Remap(1, 0, 1, AWW_Clitoris_SizeMax.val, AWW_Clitoris_SizeMax.val); }
                catch { }

                try { AWW_Clitoris_HoodSize.morphValue = Remap(1, 0, 1, AWW_Clitoris_HoodSizeMax.val, AWW_Clitoris_HoodSizeMax.val); }
                catch { }



            }
            catch { }

        }

        protected void XfloatChooserCallback(string s)
        {
            if (s != null)
            {
                if (s == "0") { xFactor.val = 0f; }
                else if (s == "1") { xFactor.val = 1f; }
                else if (s == "2") { xFactor.val = 2f; }
                else if (s == "3") { xFactor.val = 3f; }
                // Debug Line SuperController.LogMessage("Xfactor: " + xFactor.val);

            }
        }

        protected void updateVals(JSONStorableFloat xf) {

            if (xFactorstring != null)
            {
                xFactorstring.val = "\nFloat param " + xf.name + " set to " + xf.val;
            }
        }

        private void XFactorInc()
        {

            xFactor.val = xFactor.val + 1f;
            if (xFactor.val >= 7f) { xFactor.val = 6f; }
            else if (xFactor.val <= 0f) { xFactor.val = 1f; }
            //return 0;


        }

        private void XFactorDec()
        {

            xFactor.val = xFactor.val - 1f;
            if (xFactor.val <= 0f) { xFactor.val = 1f; }
            else if (xFactor.val >= 7f) { xFactor.val = 6f; }
            //return 0;


        }

        private void createSPACER(float height)
        {

            CreateSpacer(false).height = height;
            CreateSpacer(true).height = height;


        }

        private void createLeftSPACER(float height)
        {
            CreateSpacer(false).height = height;
        }

        private void createRightSPACER(float height)
        {
            CreateSpacer(true).height = height;
        }

        private void createTitle(string textTitle, Color color)
        {
            
                UIDynamicButton bTitleLMJMax = CreateButton(textTitle, false);
                UIDynamicButton bTitleLMJMin = CreateButton("", true);
                bTitleLMJMax.buttonColor = cClear;
                bTitleLMJMin.buttonColor = cClear;
                bTitleLMJMax.buttonText.fontSize = 40;
                bTitleLMJMax.textColor = color;

        }

        private void createSLIDER(JSONStorableFloat jFloat, Color jColor, bool isRightSide)
        {
            UIDynamicSlider sldSlider = CreateSlider(jFloat, isRightSide);
            //WTF why dont those work below?!?!?!?! effin a.
            //sldSlider.rangeAdjustEnabled = false;
            //sldSlider.quickButtonsEnabled = true;

            //sldSlider.labelText.color = jColor;

        }


        private float Remap(float inVal, float min1, float max1, float min2, float max2)
        {


            var ratio = (max2 - min2) / (max1 - min1);  //determine distance between open and close
            var c = min2 - ratio * min1;

            if ((ratio * inVal + c) < 0)
            {
                return OverallIntensity.val * ((ratio * inVal + c) * (ratio * inVal + c) * -1f);
            }
            else
            {
                return OverallIntensity.val * ((ratio * inVal + c) * (ratio * inVal + c)  * 1f);
            }

        }


    }
}

